use color_eyre::Result;
use subxt::{
    utils::H256,
    client::OnlineClient,
};

use crate::{CasperConfig, casper_network};

pub async fn total_issuance(
    online_client: &OnlineClient<CasperConfig>,
    at_hash: Option<&H256>,
) -> Result<Option<u128>> {
    let storage_key = casper_network::storage().balances().total_issuance();
    let maybe_total_issuance = super::do_storage_call(online_client, &storage_key, at_hash).await?;
    Ok(maybe_total_issuance)
}

pub fn existential_deposit(
    online_client: &OnlineClient<CasperConfig>,
) -> Result<u128> {
    let constant_query = casper_network::constants().balances().existential_deposit();
    let existential_deposit = super::do_constant_call(online_client, &constant_query)?;
    Ok(existential_deposit)
}
