const PROGRESS: [&str; 8] = ["▁", "▂", "▃", "▄", "▅", "▆", "▇", "█"];

pub struct VerticalBlocks {
    elements: Vec<String>,
}

impl Default for VerticalBlocks {
    fn default() -> Self {
        Self {
            elements: PROGRESS.iter().map(|s| s.to_string()).collect::<Vec<_>>(),
        }
    }
}

impl ToString for VerticalBlocks {
    fn to_string(&self) -> String {
        self.elements[((chrono::Utc::now().timestamp_millis() % super::CYCLE)
            / (super::CYCLE / self.elements.len() as i64)) as usize]
            .to_owned()
    }
}
